// SPDX-License-Identifier: Apache-2.0
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
import { CommandHandler } from "../../../../../../core/decorator/CommandHandlerDecorator";
import AccountService from "../../../../../service/account/AccountService";
import SecurityService from "../../../../../service/security/SecurityService";
import { RedeemCommand, RedeemCommandResponse } from "./RedeemCommand";
import TransactionService from "../../../../../service/transaction/TransactionService";
import { lazyInject } from "../../../../../../core/decorator/LazyInjectDecorator";
import BigDecimal from "../../../../../../domain/context/shared/BigDecimal";
import ValidationService from "../../../../../service/validation/ValidationService";
import { _PARTITION_ID_1 } from "../../../../../../core/Constants";
import ContractService from "../../../../../service/contract/ContractService";
import { RedeemCommandError } from "./error/RedeemCommandError";
let RedeemCommandHandler = class RedeemCommandHandler {
    securityService;
    transactionService;
    accountService;
    validationService;
    contractService;
    constructor(securityService, transactionService, accountService, validationService, contractService) {
        this.securityService = securityService;
        this.transactionService = transactionService;
        this.accountService = accountService;
        this.validationService = validationService;
        this.contractService = contractService;
    }
    async execute(command) {
        try {
            const { securityId, amount } = command;
            const handler = this.transactionService.getHandler();
            const account = this.accountService.getCurrentAccount();
            const securityEvmAddress = await this.contractService.getContractEvmAddress(securityId);
            await this.validationService.checkCanRedeem(securityId, account.id.toString(), amount, _PARTITION_ID_1);
            const security = await this.securityService.get(securityId);
            await this.validationService.checkDecimals(security, amount);
            const amountBd = BigDecimal.fromString(amount, security.decimals);
            const res = await handler.redeem(securityEvmAddress, amountBd, securityId);
            return Promise.resolve(new RedeemCommandResponse(res.error === undefined, res.id));
        }
        catch (error) {
            throw new RedeemCommandError(error);
        }
    }
};
RedeemCommandHandler = __decorate([
    CommandHandler(RedeemCommand),
    __param(0, lazyInject(SecurityService)),
    __param(1, lazyInject(TransactionService)),
    __param(2, lazyInject(AccountService)),
    __param(3, lazyInject(ValidationService)),
    __param(4, lazyInject(ContractService)),
    __metadata("design:paramtypes", [SecurityService,
        TransactionService,
        AccountService,
        ValidationService,
        ContractService])
], RedeemCommandHandler);
export { RedeemCommandHandler };
